package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.spec.ECNamedCurveParameterSpec;
import cn.com.infosec.jce.spec.ECNamedCurveSpec;
import cn.com.infosec.math.ec.ECCurve;
import java.math.BigInteger;
import java.security.spec.ECField;
import java.security.spec.ECFieldF2m;
import java.security.spec.ECFieldFp;
import java.security.spec.ECParameterSpec;
import java.security.spec.ECPoint;
import java.security.spec.EllipticCurve;

public class EC5Util {
   static EllipticCurve convertCurve(ECCurve curve, byte[] seed) {
      ECCurve var10003;
      BigInteger curve1;
      if (curve instanceof ECCurve.Fp) {
         ECFieldFp var6;
         ECFieldFp var7 = var6 = new ECFieldFp;
         var10003 = curve;
         var6.<init>(((ECCurve.Fp)curve).getQ());
         curve1 = curve.getA().toBigInteger();
         return new EllipticCurve(var7, curve1, var10003.getB().toBigInteger(), seed);
      } else {
         ECCurve.F2m var2;
         ECFieldF2m var10002;
         int[] var3;
         ECFieldF2m var4;
         if ((var2 = (ECCurve.F2m)curve).isTrinomial()) {
            (var3 = new int[1])[0] = var2.getK1();
            var10002 = var4 = new ECFieldF2m;
            var10003 = curve;
            var4.<init>(var2.getM(), var3);
            curve1 = curve.getA().toBigInteger();
            return new EllipticCurve(var10002, curve1, var10003.getB().toBigInteger(), seed);
         } else {
            int[] var10000 = var3 = new int[3];
            var3[0] = var2.getK3();
            var3[1] = var2.getK2();
            var10000[2] = var2.getK1();
            var10002 = var4 = new ECFieldF2m;
            var10003 = curve;
            var4.<init>(var2.getM(), var3);
            curve1 = curve.getA().toBigInteger();
            return new EllipticCurve(var10002, curve1, var10003.getB().toBigInteger(), seed);
         }
      }
   }

   static ECCurve convertCurve(EllipticCurve ec) {
      EllipticCurve var10000 = ec;
      EllipticCurve var10001 = ec;
      ECField ec1 = ec.getField();
      BigInteger var1 = var10001.getA();
      BigInteger var2 = var10000.getB();
      if (ec1 instanceof ECFieldFp) {
         return new ECCurve.Fp(((ECFieldFp)ec1).getP(), var1, var2);
      } else {
         ECFieldF2m var8 = (ECFieldF2m)ec1;
         int ec2 = ((ECFieldF2m)ec1).getM();
         int[] var3 = ECUtil.convertMidTerms(var8.getMidTermsOfReductionPolynomial());
         int var10002 = ec2;
         int[] var10003 = var3;
         ec2 = var3[0];
         int var7 = var3[1];
         int var4 = var10003[2];
         return new ECCurve.F2m(var10002, ec2, var7, var4, var1, var2);
      }
   }

   static ECParameterSpec convertSpec(EllipticCurve ellipticCurve, cn.com.infosec.jce.spec.ECParameterSpec spec) {
      BigInteger spec1;
      if (spec instanceof ECNamedCurveParameterSpec) {
         cn.com.infosec.jce.spec.ECParameterSpec var8 = spec;
         String var7 = ((ECNamedCurveParameterSpec)spec).getName();
         ECPoint var3;
         var3 = new ECPoint.<init>(spec.getG().getX().toBigInteger(), spec.getG().getY().toBigInteger());
         spec1 = spec.getN();
         BigInteger var4 = var8.getH();
         return new ECNamedCurveSpec(var7, ellipticCurve, var3, spec1, var4);
      } else {
         EllipticCurve var10002 = ellipticCurve;
         cn.com.infosec.jce.spec.ECParameterSpec var10003 = spec;
         ECPoint ellipticCurve1;
         ellipticCurve1 = new ECPoint.<init>(spec.getG().getX().toBigInteger(), spec.getG().getY().toBigInteger());
         spec1 = spec.getN();
         int var2 = var10003.getH().intValue();
         return new ECParameterSpec(var10002, ellipticCurve1, spec1, var2);
      }
   }

   static cn.com.infosec.jce.spec.ECParameterSpec convertSpec(ECParameterSpec ecSpec, boolean withCompression) {
      ECCurve var2 = convertCurve(ecSpec.getCurve());
      ECCurve var10002 = var2;
      ECParameterSpec var10003 = ecSpec;
      ECParameterSpec var10004 = ecSpec;
      ECParameterSpec var10005 = ecSpec;
      cn.com.infosec.math.ec.ECPoint ecSpec1 = convertPoint(var2, ecSpec.getGenerator(), withCompression);
      BigInteger withCompression1 = var10005.getOrder();
      BigInteger var6 = BigInteger.valueOf((long)var10004.getCofactor());
      byte[] var3 = var10003.getCurve().getSeed();
      return new cn.com.infosec.jce.spec.ECParameterSpec(var10002, ecSpec1, withCompression1, var6, var3);
   }

   static cn.com.infosec.math.ec.ECPoint convertPoint(ECParameterSpec ecSpec, ECPoint point, boolean withCompression) {
      return convertPoint(convertCurve(ecSpec.getCurve()), point, withCompression);
   }

   static cn.com.infosec.math.ec.ECPoint convertPoint(ECCurve curve, ECPoint point, boolean withCompression) {
      ECCurve var10000 = curve;
      BigInteger curve1 = point.getAffineX();
      return var10000.createPoint(curve1, point.getAffineY(), withCompression);
   }
}
